// ----------------------------------------
// Работа с полосой просмотра
// ----------------------------------------

#define STRICT
#include <windows.h>
#include <mem.h>

// Идентификатор полосы просмотра
#define ID_SCROLL 1

// Прототипы функций
BOOL InitApp(HINSTANCE);
LRESULT CALLBACK _export WndProc(HWND, UINT, WPARAM, LPARAM);

// Имя класса окна
char const szClassName[]   = "ScrollAppClass";

// Заголовок окна
char const szWindowTitle[] = "Scroll Demo";

// Текущая позиция полосы просмотра
int nPosition;

// Идентификатор окна полосы просмотра
HWND hScroll;

// Идентификатор статического органа
// управления
HWND hStatic;

// =====================================
// Функция WinMain
// =====================================
#pragma argsused

int PASCAL
WinMain(HINSTANCE hInstance, 
	HINSTANCE hPrevInstance,
	LPSTR     lpszCmdLine, 
	int       nCmdShow)   
{
  MSG  msg;   // структура для работы с сообщениями
  HWND hwnd;  // идентификатор главного окна приложения

  // Инициализируем приложение
  if(!InitApp(hInstance))
      return FALSE;

  // После успешной инициализации приложения создаем
  // главное окно приложения
  hwnd = CreateWindow(
    szClassName,         // имя класса окна
    szWindowTitle,       // заголовок окна
    WS_OVERLAPPEDWINDOW, // стиль окна
    CW_USEDEFAULT,       // задаем размеры и расположение
    CW_USEDEFAULT,       // окна, принятые по умолчанию 
    CW_USEDEFAULT,
    CW_USEDEFAULT,
    0,                   // идентификатор родительского окна
    0,                   // идентификатор меню
    hInstance,           // идентификатор приложения
    NULL);               // указатель на дополнительные
			 // параметры

  // Если создать окно не удалось, завершаем приложение
  if(!hwnd)
    return FALSE;

  // Рисуем главное окно
  ShowWindow(hwnd, nCmdShow);
  UpdateWindow(hwnd);

  // Создаем полосу просмотра
  hScroll = CreateWindow("scrollbar", NULL,
    WS_CHILD | WS_VISIBLE | SBS_HORZ,
    20, 60,
    200, 15,
    hwnd,
    (HMENU) ID_SCROLL,
    hInstance, NULL);

  // Устанавливаем текущую позицию
  nPosition = 100;

  // Устанавливаем минимальное и максимальное
  // значения для полосы просмотра
  SetScrollRange(hScroll, SB_CTL, 1, 200, TRUE);

  // Устанавливаем ползунок в середину
  // полосы просмотра
  SetScrollPos(hScroll, SB_CTL, nPosition, TRUE);

  // Создаем статический орган управления в виде
  // черного прямоугольника. Длина этого
  // прямоугольника будет определяеться текущей
  // позицией полосы просмотра
  hStatic = CreateWindow("static", NULL,
    WS_CHILD | WS_VISIBLE | SS_BLACKRECT,
    20, 40,
    nPosition, 15,
    hwnd, (HMENU) -1,hInstance, NULL);

  // Запускаем цикл обработки сообщений
  while(GetMessage(&msg, 0, 0, 0))
  {
    DispatchMessage(&msg);
  }
  return msg.wParam;
}

// =====================================
// Функция InitApp
// Выполняет регистрацию класса окна
// =====================================

BOOL
InitApp(HINSTANCE hInstance)
{
  ATOM aWndClass; // атом для кода возврата
  WNDCLASS wc;    // структура для регистрации
                  // класса окна

  memset(&wc, 0, sizeof(wc));

  wc.style = 0;
  wc.lpfnWndProc = (WNDPROC) WndProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance = hInstance;
  wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
  wc.lpszMenuName = (LPSTR)NULL;
  wc.lpszClassName = (LPSTR)szClassName;

  // Регистрация класса
  aWndClass = RegisterClass(&wc);

  return (aWndClass != 0);
}

// =====================================
// Функция WndProc
// =====================================


LRESULT CALLBACK _export
WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch (msg)
  {
    // Сообщение от горизонтальной полосы просмотра
    case WM_HSCROLL:
    {
      // В зависимости от параметра сообщения
      // изменяем текущую позицию
      switch (wParam)
      {
	case SB_PAGEDOWN:
	{
	  nPosition += 10;
	  break;
        }
	case SB_LINEDOWN:
	{
	  nPosition += 1;
	  break;
        }
	case SB_PAGEUP:
	{
	  nPosition -= 10;
	  break;
        }
	case SB_LINEUP:
	{
	  nPosition -= 1;
	  break;
        }
	case SB_TOP:
	{
          nPosition = 0;
	  break;
        }
	case SB_BOTTOM:
	{
	  nPosition = 200;
	  break;
        }
	case SB_THUMBPOSITION:
	{
          nPosition = LOWORD (lParam);
	  break;
        }
	case SB_THUMBTRACK:
	{
	  nPosition = LOWORD (lParam);
	  break;
        }
	default:
          break;
      }

      // Ограничиваем пределы изменения текущей
      // позиции значениями от 1 до 200
      if(nPosition > 200) nPosition = 200;
      if(nPosition < 1) nPosition = 1;

      // Устанавливаем ползунок полосы просмотра
      // в соответствии с новым значением
      // текущей позиции
      SetScrollPos(hScroll, SB_CTL, nPosition, TRUE);

      // Устанавливаем новый размер статического
      // органа управления
      MoveWindow(hStatic, 20, 40, nPosition, 15, TRUE);

      return 0;
    }

    // Обеспечиваем управление полосой просмотра
    // при помощи клавиатуры
    case WM_KEYDOWN:
    {
      // В зависимости от кода клавиши функция окна
      // посылает сама себе сообщения, которые
      // обычно генерируются полосой просмотра
      switch (wParam)
      {
	case VK_HOME:
	{
	  SendMessage(hwnd, WM_HSCROLL, SB_TOP, 0L);
          break;
        }
	case VK_END:
	{
	  SendMessage(hwnd, WM_HSCROLL, SB_BOTTOM, 0L);
          break;
        }
	case VK_LEFT:
	{
	  SendMessage(hwnd, WM_HSCROLL, SB_LINEUP, 0L);
          break;
        }
	case VK_RIGHT:
	{
	  SendMessage(hwnd, WM_HSCROLL, SB_LINEDOWN, 0L);
          break;
        }
	case VK_PRIOR:
	{
	  SendMessage(hwnd, WM_HSCROLL, SB_PAGEUP, 0L);
          break;
        }
	case VK_NEXT:
	{
	  SendMessage(hwnd, WM_HSCROLL, SB_PAGEDOWN, 0L);
          break;
        }
      }
      return 0;
    }
    case WM_DESTROY:
    {
      PostQuitMessage(0);
      return 0;
    }
  }
  return DefWindowProc(hwnd, msg, wParam, lParam);
}